#include <avr/io.h>
#define F_CPU 8000000					//     8 

//#include <util/delay.h>
#include <avr/interrupt.h>
//#include <avr/eeprom.h>
//PORTB |= (1 << n); //  
//PORTB &= ~(1 << 0); //  
#define pwm_start 20					// 


volatile unsigned int pulse_length=0,count_length=0,impuls_count=0,time_stop=0;
volatile unsigned char pwm,new_length=0,temp;

ISR(TIM1_OVF_vect)
{
count_length++;
}

ISR(INT0_vect)
{

temp=TCNT1;					//   1

if(PINB&(1<<PINB2))
	{						//  ,   1
	TCNT1=0;
	TCCR1=(1<<CS12);		//  8
	}
else
	{						//  ,        
	TCCR1=0;
	pulse_length=(count_length<<8)+temp;
	new_length=1;
	count_length=0;
	
	};
};

ISR(ANA_COMP_vect)
{
stop_pwm();
PORTB=0;
while(1);	
}


void stop_pwm(void)		
	{
	TCCR0A=0;
	TCCR0B=0;
	PORTB &=0b11111100;
	}
	

int main (void) 
	{
unsigned char i;

TCCR0A=0;
TCCR0B=0;

PORTB=0b00010000;
DDRB= 0b00010011;

GIMSK=(1<<INT0);		//   ;
MCUCR=(1<<ISC00);		//     


TIMSK=(1<<TOIE1);				//   1 
TCCR1=0;

ACSR=((1<<ACIE)|(1<<ACIS0)|(1<<ACIS1)|(1<<ACBG));			// ,  ,        1,1

ADCSRA=0x00;					// 		
ADCSRB=(1<<ACME);    			//      

ADMUX=((1<<MUX0)|(1<<MUX1));	//    ADC3


if(ACSR&(1<<ACO)) 				//  ,  1    
	{
	PORTB=0;					// 
	while(1);
	};

sei();
	while(1)
		{	
		if(new_length)
				{
				new_length=0;
				if ((pulse_length>2250)||(pulse_length<750))	//,     785    2250,   
					{
					stop_pwm();	//    2,5,   0,75    
					}
				else
					{
			
				if ((pulse_length<(1500+pwm_start))&&(pulse_length>(1500-pwm_start)))stop_pwm(); //   ,   
		
				if (pulse_length<=(1500-pwm_start))					//
					{
					TCCR0A=((1<<WGM00)|(1<<WGM01)|(1<<COM0B1));
					PORTB &= ~(1 << 0); 			//  
					if(pulse_length<1000)OCR0B=255;else OCR0B=((1500-pulse_length)>>1)+5;
					TCCR0B=(1<<CS01);					//  8
					};
		
				if (pulse_length>=(1500+pwm_start))					//	
					{
					TCCR0A=((1<<WGM00)|(1<<WGM01)|(1<<COM0A1));
					PORTB &= ~(1 << 1); 			//  
					if(pulse_length>2000)OCR0A=255;else OCR0A=((pulse_length-1500)>>1)+5;
					TCCR0B=(1<<CS01);					//  8
					};
				};
			};
		};
		
	return  0;	
	}